//////////////////////////////////////////////////////////////////////
/*****************************************************************/
// This file is a part of the E-XD++ MFC Extension Class.
// 2001-201? ucancode.net Software, All Rights Reserved.
// This is only define for UCanCode Software E-XD++ Library.
//
// UCanCode SOFTWARE GRANTS TO YOU (ONE SOFTWARE PROGRAMMER) THE
// LIMITED RIGHT TO USE THIS SOFTWARE ON A SINGLE COMPUTER.  
//  THESE SOURCE FILE ARE CONSIDERED CONFIDENTIONAL AND ARE 
// THE PROPERTY OF UCanCode SOFTWARE AND ARE NOT TO BE RE-DISTRIBUTED
// BY ANY MEANS WHATSOEVER WITHOUT THE EXPRESSED WRITTEN CONSENT OF 
// UCanCode SOFTWARE.
// 
// You can contact us.
// Support@ucancode.net
// http://www.ucancode.net
/********************************************************************/
// FOPGDIPlusHelper.cpp : Defines the class behaviors for the application.
//
 
#include "stdafx.h"
#include "FOPGDIPlusHelper.h"
#include "FOGlobals.h"
 
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define FO_MAX_GDI_OBJECTS 2
 
SmoothingMode HokGdiPlusG::m_smoothingMode = SmoothingModeHighQuality;

//////////////////////////////////////////////////////////////////////////////////////////////////////
//	Pen
CFOPHokPenCache* CFOPHokPenCache::m_psPenCache = NULL;

CFOPHokPenCache::CFOPHokPenCache()
{
	if (m_psPenCache != NULL)
		ASSERT(m_psPenCache);
	else
		m_psPenCache = this;
}

CFOPHokPenCache::~CFOPHokPenCache()
{
	m_psPenCache = NULL;
}

CFOPHokPenCache* CFOPHokPenCache::GetInstance()
{
	if (m_psPenCache == NULL)
		m_psPenCache = new CFOPHokPenCache;

	ASSERT(m_psPenCache);
	return m_psPenCache;
}

void CFOPHokPenCache::DestoryInstance()
{
	if (m_psPenCache != NULL)
	{
		FOPHokPen *pPenTemp = NULL;
		POSITION pos = m_psPenCache->GetHeadPosition();
		while (pos)
		{
			pPenTemp = (FOPHokPen*)m_psPenCache->GetNext(pos);
			_SafeDeletePtr(pPenTemp->m_pPen);
			_SafeDeletePtr(pPenTemp);
		}
		m_psPenCache->RemoveAll();
	}
	_SafeDeletePtr(m_psPenCache);
}
 
Pen* CFOPHokPenCache::FindPen(FOPHokPenStyle &hokPenStyle)
{
// 	FOPHokPen* pCurFOPHokPen = NULL;
// 	POSITION pos = GetHeadPosition();
// 	while (pos)
// 	{
// 		pCurFOPHokPen = GetNext(pos);
// 		if (hokPenStyle == pCurFOPHokPen->m_penStyle)
// 		{
// 			ASSERT(pCurFOPHokPen->m_pPen);
// 			return pCurFOPHokPen->m_pPen;
// 		}
// 	}

	return CreatePen(hokPenStyle);
}

Pen* CFOPHokPenCache::CreatePen(FOPHokPenStyle &hokPenStyle)
{
	FOPHokPen* hokPenTemp = new FOPHokPen();
	ASSERT(hokPenTemp);

	hokPenTemp->m_penStyle = hokPenStyle;

	int nWidth = hokPenStyle.GetPenWidth();
	hokPenTemp->m_pPen = new Pen(hokPenStyle.GetPenColor(), hokPenStyle.GetPenWidth());
	ASSERT(hokPenTemp->m_pPen);
	hokPenTemp->m_pPen->SetLineJoin(LineJoinMiter);
// 	enum LineJoin
// 	{
// 		LineJoinMiter        = 0,
// 			LineJoinBevel        = 1,
// 			LineJoinRound        = 2,
// 			LineJoinMiterClipped = 3
// };
	if( nWidth < 2)
	{
	
			int nStyle = hokPenStyle.GetDashStyle();
			if(nStyle == DashStyleDash)
			{
				REAL dashVals[2] = {  
					16.0f,
						4.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
			}
			else if(nStyle == DashStyleDot)
			{
				REAL dashVals[2] = {  
					8.0f,
						8.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
			}
			else if(nStyle == DashStyleDashDot)
			{
				REAL dashVals[4] = {  
					16.0f,
						4.0f,  
						8.0f,
					4.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 4);
			}
			else if(nStyle == DashStyleDashDotDot)
			{
				REAL dashVals[6] = {  
					16.0f,
					4.0f,  
					8.0f,
					4.0f,
					8.0f,
					4.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 6);
			}
			
	}
	else if( nWidth < 3)
	{
			int nStyle = hokPenStyle.GetDashStyle();
			if(nStyle == DashStyleDash)
			{
				REAL dashVals[2] = {  
					10.0f,
						4.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
			}
			else if(nStyle == DashStyleDot)
			{
				REAL dashVals[2] = {  
					5.0f,
						5.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
			}
			else if(nStyle == DashStyleDashDot)
			{
				REAL dashVals[4] = {  
					10.0f,
						4.0f,  
						5.0f,
						4.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 4);
			}
			else if(nStyle == DashStyleDashDotDot)
			{
				REAL dashVals[6] = {  
					10.0f,
						4.0f,  
						5.0f,
						4.0f,
						5.0f,
						4.0f};
					hokPenTemp->m_pPen->SetDashPattern(dashVals, 6);
			}
			
	}
	else if( nWidth < 4)
	{
		int nStyle = hokPenStyle.GetDashStyle();
		if(nStyle == DashStyleDash)
		{
			REAL dashVals[2] = {  
				8.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
		}
		else if(nStyle == DashStyleDot)
		{
			REAL dashVals[2] = {  
				4.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
		}
		else if(nStyle == DashStyleDashDot)
		{
			REAL dashVals[4] = {  
				8.0f,
					4.0f,  
					4.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 4);
		}
		else if(nStyle == DashStyleDashDotDot)
		{
			REAL dashVals[6] = {  
				8.0f,
					4.0f,  
					4.0f,
					4.0f,
					4.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 6);
		}
		
	}
	else if( nWidth < 5)
	{
		int nStyle = hokPenStyle.GetDashStyle();
		if(nStyle == DashStyleDash)
		{
			REAL dashVals[2] = {  
				10.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
		}
		else if(nStyle == DashStyleDot)
		{
			REAL dashVals[2] = {  
				5.0f,
					5.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 2);
		}
		else if(nStyle == DashStyleDashDot)
		{
			REAL dashVals[4] = {  
				10.0f,
					4.0f,  
					5.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 4);
		}
		else if(nStyle == DashStyleDashDotDot)
		{
			REAL dashVals[6] = {  
				10.0f,
					4.0f,  
					5.0f,
					4.0f,
					5.0f,
					4.0f};
				hokPenTemp->m_pPen->SetDashPattern(dashVals, 6);
		}
		
	}
	else
	{
		hokPenTemp->m_pPen->SetDashStyle(hokPenStyle.GetDashStyle());
	}
	
//	hokPenTemp->m_pPen->SetLineJoin(Miter);
// 	AddTail(hokPenTemp);
// 	
// 	int nCount = GetCount();
// 	if(nCount >= FO_MAX_GDI_OBJECTS)
// 	{
// 		FOPHokPen *pPenTemp = GetHead();
// 		if(pPenTemp != NULL)
// 		{
// 			RemoveAt(GetHeadPosition());
// 			_SafeDeletePtr(pPenTemp->m_pPen);
// 			_SafeDeletePtr(pPenTemp);
// 		}
// 	}

	TRACE(_T("Create: Pen Count: (%d)\n"), GetCount());
	Pen* returnPen = hokPenTemp->m_pPen;
	delete hokPenTemp;
	return returnPen;
}

Pen* CFOPHokPenCache::GetPen(CPen * pPen, const BYTE &nA)
{
	if (NULL == pPen) return NULL;

	LOGPEN logpen;
	if (pPen->GetLogPen(&logpen))
	{
		if (logpen.lopnStyle >= PS_NULL) 
			return NULL;

		UINT style = logpen.lopnStyle&PS_STYLE_MASK;
		Color cr;
		cr = Color(nA, GetRValue(logpen.lopnColor),GetGValue(logpen.lopnColor),GetBValue(logpen.lopnColor));
		REAL fPenWidth = (logpen.lopnWidth.x == 0)? 1.0f:logpen.lopnWidth.x;
		FOPHokPenStyle penStyle(cr, fPenWidth, DashStyle(style));

		return FindPen(penStyle);
	}
	
	int size = ::GetObject(pPen->GetSafeHandle(), 0, NULL);
	if (size>0)
	{
		EXTLOGPEN *pPenEx = (EXTLOGPEN*) new char[size];
		if (GetObject(pPen->GetSafeHandle(), size, pPenEx) != 0)
		{
			Color cr;
			COLORREF crx = pPenEx->elpColor;
			cr = Color(nA, GetRValue(crx),GetGValue(crx),GetBValue(crx));
			REAL fPenWidth  = (pPenEx->elpWidth == 0)? 1.0f:pPenEx->elpWidth;

			REAL pDashValues[6] = {0,};
			for(int i = 0; i < (int)pPenEx->elpNumEntries; i++)
			{
				if (pPenEx->elpStyleEntry[i] == 1)
					pDashValues[i] = 1;
				else
					pDashValues[i] = pPenEx->elpStyleEntry[i]/fPenWidth;
			}

			DashStyle dashStyle = GetDashStyleByArr(pDashValues, pPenEx->elpNumEntries);

			FOPHokPenStyle penStyle(cr, fPenWidth, dashStyle);

			delete [](char*)pPenEx;
			return FindPen(penStyle);
		}
		delete [](char*)pPenEx;
	}
	return NULL;
}

DashStyle CFOPHokPenCache::GetDashStyleByArr(REAL *pArr, int nSize)
{
	if (2 == nSize)
	{
		if (pArr[0] == 1 && pArr[1] == 3)
		{
			return DashStyleDot;
		}

		if (pArr[0] == 2 && pArr[1] == 4)
		{
			return DashStyleDash;
		}

		if (pArr[0] == 3 && pArr[1] == 6)
		{
			return DashStyleDash;
		}

		if (pArr[0] == 1 && pArr[1] == 4.5)
		{
			return DashStyleDot;
		}
	}

	if (4 == nSize) 
	{
		if (pArr[0] == 2 && pArr[1] == 4&& pArr[2] == 1&& pArr[3] == 4)
		{
			return DashStyleDashDot;
		}

		if (pArr[0] == 3 && pArr[1] == 6&& pArr[2] == 1&& pArr[3] == 6)
		{
			return DashStyleDashDot;
		}
	}

	if (6 == nSize) 
	{
		if (pArr[0] == 2 && pArr[1] == 3&& pArr[2] == 1
			&& pArr[3] == 3&& pArr[4] == 1&& pArr[5] == 3)
		{
			return DashStyleDashDotDot;
		}

		if (pArr[0] == 3 && pArr[1] == 4.5&& pArr[2] == 1
			&& pArr[3] == 4.5&& pArr[4] == 1&& pArr[5] == 4.5)
		{
			return DashStyleDashDotDot;
		}
	}
	return DashStyleSolid;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
//	Brush
CFOPHokBrushCache* CFOPHokBrushCache::m_psBrushCache = NULL;

CFOPHokBrushCache::CFOPHokBrushCache()
{
	if (m_psBrushCache != NULL)
		ASSERT(m_psBrushCache);
	else
		m_psBrushCache = this;
}

CFOPHokBrushCache::~CFOPHokBrushCache()
{
	ASSERT(m_psBrushCache != NULL);
}

CFOPHokBrushCache* CFOPHokBrushCache::GetInstance()
{
	if (m_psBrushCache == NULL)
		m_psBrushCache = new CFOPHokBrushCache;

	ASSERT(m_psBrushCache);
	return m_psBrushCache;
}

void CFOPHokBrushCache::DestoryInstance()
{
	if (m_psBrushCache != NULL)
	{
		FOPHokBrush *pBrushTemp = NULL;
		POSITION pos = m_psBrushCache->GetHeadPosition();
		while (pos)
		{
			pBrushTemp = (FOPHokBrush*)m_psBrushCache->GetNext(pos);
			_SafeDeletePtr(pBrushTemp->m_pBrush);
			_SafeDeletePtr(pBrushTemp);
		}
		m_psBrushCache->RemoveAll();
	}
	_SafeDeletePtr(m_psBrushCache);
}

Brush* CFOPHokBrushCache::FindBrush(FOPHokBrushStyle &hokBrushStyle)
{
// 	FOPHokBrush* pCurFOPHokBrush = NULL;
// 	POSITION pos = GetHeadPosition();
// 	while (pos)
// 	{
// 		pCurFOPHokBrush = GetNext(pos);
// 		if (hokBrushStyle == pCurFOPHokBrush->m_brushStyle)
// 		{
// 			ASSERT(pCurFOPHokBrush->m_pBrush);
// 			return pCurFOPHokBrush->m_pBrush;
// 		}
// 	}
	return CreateBrush(hokBrushStyle);
}

Brush* CFOPHokBrushCache::CreateBrush(FOPHokBrushStyle &hokBrushStyle)
{
	Brush* brush = NULL;
	int nFillType = hokBrushStyle.GetBrushType();

	if (1 == nFillType)
	{
		brush = new SolidBrush(hokBrushStyle.GetFirColor());
	}
	else if (2 == nFillType)
	{
		brush = new SolidBrush(hokBrushStyle.GetSecColor());
	}
	else if (2 < nFillType && nFillType< 42)
	{// 3-41 -- fill with hatch pattern.
		brush = new HatchBrush((HatchStyle)(HatchStyleMin + nFillType - 3), 
					hokBrushStyle.GetSecColor(), hokBrushStyle.GetFirColor());
	}
	else if (62 <= nFillType && nFillType < 92)
	{// 62 - 91 Fill with pattern bitmap.
		HBITMAP m_hbm = HBITMAP(gfxData.bitmap[nFillType-62].GetSafeHandle());
		Bitmap *pBitmap = Bitmap::FromHBITMAP(m_hbm, NULL);
		brush = new TextureBrush(pBitmap, WrapModeTile);
		if(pBitmap != NULL)
		{
			delete pBitmap;
		}
	}
	else
	{
		return NULL;
	}

	ASSERT(brush);
// 	FOPHokBrush* hokBrushTemp = new FOPHokBrush(brush);
// 	ASSERT(hokBrushTemp);
// 	hokBrushTemp->m_brushStyle = hokBrushStyle;
// 
// 	AddTail(hokBrushTemp);
// 
// 	int nCount = GetCount();
// 	if(nCount >= FO_MAX_GDI_OBJECTS)
// 	{
// 		FOPHokBrush *pBrushTemp = GetHead();
// 		if(pBrushTemp != NULL)
// 		{
// 			RemoveAt(GetHeadPosition());
// 			_SafeDeletePtr(pBrushTemp->m_pBrush);
// 			_SafeDeletePtr(pBrushTemp);
// 		}
// 	}
//
//	TRACE(_T("Create a new brush in cache. Count = [%d].\n"), GetCount());
	return brush;
}

FOPHokBrushStyle CFOPHokBrushCache::GetStyle(Brush *pBrush)
{
	FOPHokBrush* pCurFOPHokBrush = NULL;
	POSITION pos = GetHeadPosition();
	while (pos)
	{
		pCurFOPHokBrush = GetNext(pos);
		if (pBrush == pCurFOPHokBrush->m_pBrush)
		{
			return pCurFOPHokBrush->m_brushStyle;
		}
	}
	ASSERT(FALSE);
	FOPHokBrushStyle hokBrushStyle;
	return hokBrushStyle;
}

Brush* CFOPHokBrushCache::GetBrush(UINT nFillType, COLORREF crStart, COLORREF crEnd, const BYTE &nAStart, const BYTE &nAEnd)
{
	if(nFillType <= 0)
	{
		return NULL;
	}

	FOPHokBrushStyle hokBrushStyle(nFillType);

	Color crFir;
	crFir = Color(nAStart, GetRValue(crStart),GetGValue(crStart),GetBValue(crStart));
	hokBrushStyle.SetFirColor(crFir);

	Color crSec;
	crSec = Color(nAEnd, GetRValue(crEnd),GetGValue(crEnd),GetBValue(crEnd));

	hokBrushStyle.SetSecColor(crSec);

	return FindBrush(hokBrushStyle);
}

Brush* CFOPHokBrushCache::CreateGradientBrush(UINT nBrTypeIn, COLORREF crEndIn, COLORREF crStartIn, CRect rcIn, 
											  const BYTE &nAStart, const BYTE &nAEnd)
{
	Brush *pBrush = NULL;
	LinearGradientBrush *pLinearBrush = NULL;
	PathGradientBrush *pPathBrush = NULL;

	UINT nBrType = nBrTypeIn-42;

	Color crStart, crEnd;
	crStart = Color(nAStart, GetRValue(crStartIn),GetGValue(crStartIn),GetBValue(crStartIn));
	crEnd = Color(nAEnd, GetRValue(crEndIn),GetGValue(crEndIn),GetBValue(crEndIn));
	
	Rect rc(rcIn.left, rcIn.top, rcIn.Width(), rcIn.Height());

	switch(nBrType)
	{
	case GRADIENT_HORZ_TOP_BOTTOM:
		pBrush = new LinearGradientBrush(rc, crStart, crEnd, LinearGradientModeVertical);
		break;
		
	case GRADIENT_HORZ_BOTTOM_TOP:
		pBrush = new LinearGradientBrush(rc, crEnd, crStart, LinearGradientModeVertical);
		break;
		
	case GRADIENT_VERT_LEFT_RIGHT:
		pBrush = new LinearGradientBrush(rc, crEnd, crStart, LinearGradientModeHorizontal);
		break;

	case GRADIENT_VERT_RIGHT_LEFT:
		pBrush = new LinearGradientBrush(rc, crStart, crEnd, LinearGradientModeHorizontal);
		break;
		
	case GRADIENT_HORZ_CENTER_OUT:
		{
			REAL factors[3] = {0.0f, 1.0f, 0.0f};
			REAL positions[3] = {0.0f, 0.5f, 1.0f};
			pLinearBrush = new LinearGradientBrush(rc, crStart, crEnd, LinearGradientModeVertical);	
			pLinearBrush->SetBlend(factors, positions, 3);

			pBrush = pLinearBrush;
		}
		break;

	case GRADIENT_HORZ_CENTER_IN:
		{
			REAL factors[3] = {0.0f, 1.0f, 0.0f};
			REAL positions[3] = {0.0f, 0.5f, 1.0f};
			pLinearBrush = new LinearGradientBrush(rc, crEnd, crStart, LinearGradientModeVertical);	
			pLinearBrush->SetBlend(factors, positions, 3);
			
			pBrush = pLinearBrush;
		}
		break;

	case GRADIENT_VERT_MIDDLE_OUT:
		{
			REAL factors[3] = {0.0f, 1.0f, 0.0f};
			REAL positions[3] = {0.0f, 0.5f, 1.0f};
			pLinearBrush = new LinearGradientBrush(rc, crEnd, crStart, LinearGradientModeHorizontal);	
			pLinearBrush->SetBlend(factors, positions, 3);

			pBrush = pLinearBrush;
		}
		break;

	case GRADIENT_VERT_MIDDLE_IN:
		{
			REAL factors[3] = {0.0f, 1.0f, 0.0f};
			REAL positions[3] = {0.0f, 0.5f, 1.0f};
			pLinearBrush = new LinearGradientBrush(rc, crStart, crEnd, LinearGradientModeHorizontal);	
			pLinearBrush->SetBlend(factors, positions, 3);

			pBrush = pLinearBrush;
		}
		break;

	case GRADIENT_CORNER_TOP_LEFT:
		{
			Point pts[] = {Point(rc.GetLeft(), rc.GetTop()), Point(rc.GetRight(), rc.GetTop()), 
					Point(rc.GetRight(), rc.GetBottom()), Point(rc.GetLeft(), rc.GetBottom())};

			pPathBrush = new PathGradientBrush(pts, 4);	

			int count = 4;
			Color colors[] = {crStart, crStart, crStart, crStart};
			pPathBrush->SetSurroundColors(colors, &count);
			pPathBrush->SetCenterColor(crEnd);
			pPathBrush->SetCenterPoint(pts[0]);

			pBrush = pPathBrush;
		}
		break;
		
	case GRADIENT_CORNER_RIGHT_TOP:
		{
			Point pts[] = {Point(rc.GetLeft(), rc.GetTop()), Point(rc.GetRight(), rc.GetTop()), 
					Point(rc.GetRight(), rc.GetBottom()), Point(rc.GetLeft(), rc.GetBottom())};

			pPathBrush = new PathGradientBrush(pts, 4);	

			int count = 4;
			Color colors[] = {crStart, crStart, crStart, crStart};
			pPathBrush->SetSurroundColors(colors, &count);
			pPathBrush->SetCenterColor(crEnd);
			pPathBrush->SetCenterPoint(pts[1]);

			pBrush = pPathBrush;
		}
		break;
		
	case GRADIENT_CORNER_RIGHT_BOTTOM:
		{
			Point pts[] = {Point(rc.GetLeft(), rc.GetTop()), Point(rc.GetRight(), rc.GetTop()), 
					Point(rc.GetRight(), rc.GetBottom()), Point(rc.GetLeft(), rc.GetBottom())};

			pPathBrush = new PathGradientBrush(pts, 4);	

			int count = 4;
			Color colors[] = {crStart, crStart, crStart, crStart};
			pPathBrush->SetSurroundColors(colors, &count);
			pPathBrush->SetCenterColor(crEnd);
			pPathBrush->SetCenterPoint(pts[2]);
			
			pBrush = pPathBrush;
		}
		break;
		
	case GRADIENT_CORNER_BOTTOM_LEFT:
		{
			Point pts[] = {Point(rc.GetLeft(), rc.GetTop()), Point(rc.GetRight(), rc.GetTop()), 
					Point(rc.GetRight(), rc.GetBottom()), Point(rc.GetLeft(), rc.GetBottom())};

			pPathBrush = new PathGradientBrush(pts, 4);	

			int count = 4;
			Color colors[] = {crStart, crStart, crStart, crStart};
			pPathBrush->SetSurroundColors(colors, &count);
			pPathBrush->SetCenterColor(crEnd);
			pPathBrush->SetCenterPoint(pts[3]);

			pBrush = pPathBrush;
		}
		break;

	case GRADIENT_TITLE_OUT:
		{
			Point pts[] = {Point(rc.GetLeft(), rc.GetTop()), Point(rc.GetRight(), rc.GetTop()), 
					Point(rc.GetRight(), rc.GetBottom()), Point(rc.GetLeft(), rc.GetBottom())};

			pPathBrush = new PathGradientBrush(pts, 4);	

			int count = 4;
			Color colors[] = {crStart, crStart, crStart, crStart};
			pPathBrush->SetSurroundColors(colors, &count);
			pPathBrush->SetCenterColor(crEnd);
			pPathBrush->SetCenterPoint(Point(rc.X+INT(rc.Width/2), rc.Y+INT(rc.Height/2)));

			pBrush = pPathBrush;
		}
		break;
		
	case GRADIENT_TITLE_IN:
		{
			Point pts[] = {Point(rc.GetLeft(), rc.GetTop()), Point(rc.GetRight(), rc.GetTop()), 
					Point(rc.GetRight(), rc.GetBottom()), Point(rc.GetLeft(), rc.GetBottom())};

			pPathBrush = new PathGradientBrush(pts, 4);	

			int count = 4;
			Color colors[] = {crEnd, crEnd, crEnd, crEnd};
			pPathBrush->SetSurroundColors(colors, &count);
			pPathBrush->SetCenterColor(crStart);
			pPathBrush->SetCenterPoint(Point(rc.X+INT(rc.Width/2), rc.Y+INT(rc.Height/2)));

			pBrush = pPathBrush;
		}
		break;

	case GRADIENT_ELLIPSE_OUT:
		{
			GraphicsPath path;
			path.AddEllipse(rc);
			
			pPathBrush = new PathGradientBrush(&path);
			pPathBrush->SetGammaCorrection(TRUE);
			INT num = 1;
			pPathBrush->SetSurroundColors(&crEnd, &num);
			pPathBrush->SetCenterColor(crStart);
			
			pBrush = pPathBrush;
			
		}
		break;
		
	case GRADIENT_ELLIPSE_IN:
		{
			GraphicsPath path;
			path.AddEllipse(rc);
			
			pPathBrush = new PathGradientBrush(&path);
			pPathBrush->SetGammaCorrection(TRUE);
			INT num = 1;
			pPathBrush->SetSurroundColors(&crStart, &num);
			pPathBrush->SetCenterColor(crEnd);
			
			pBrush = pPathBrush;
		}
		break;

	case GRADIENT_ANGLE_45:
		pBrush = new LinearGradientBrush(rc, crEnd, crStart, LinearGradientModeForwardDiagonal);
		break;

	case GRADIENT_ANGLE_135:
		pBrush = new LinearGradientBrush(rc, crStart, crEnd, LinearGradientModeBackwardDiagonal);
		break;

	case GRADIENT_ANGLE_225:
		pBrush = new LinearGradientBrush(rc, crStart, crEnd, LinearGradientModeForwardDiagonal);
		break;

	case GRADIENT_ANGLE_315:
		pBrush = new LinearGradientBrush(rc, crEnd, crStart, LinearGradientModeBackwardDiagonal);
		break;
	}
	return pBrush;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////
// Font
CFOPHokFontCache* CFOPHokFontCache::m_psFontCache = NULL;

CFOPHokFontCache::CFOPHokFontCache()
{
	if (m_psFontCache != NULL)
		ASSERT(m_psFontCache);
	else
		m_psFontCache = this;
}

CFOPHokFontCache::~CFOPHokFontCache()
{
	m_psFontCache = NULL;
}

CFOPHokFontCache* CFOPHokFontCache::GetInstance()
{
	if (m_psFontCache == NULL)
		m_psFontCache = new CFOPHokFontCache;

	ASSERT(m_psFontCache);
	return m_psFontCache;
}

void CFOPHokFontCache::DestoryInstance()
{
	if (m_psFontCache != NULL)
	{
		FOPHokFont *pFontTemp = NULL;
		POSITION pos = m_psFontCache->GetHeadPosition();
		while (pos)
		{
			pFontTemp = (FOPHokFont*)m_psFontCache->GetNext(pos);
			_SafeDeletePtr(pFontTemp->m_pFont);
			_SafeDeletePtr(pFontTemp);
		}
		m_psFontCache->RemoveAll();
	}
	_SafeDeletePtr(m_psFontCache);
}

Gdiplus::Font* CFOPHokFontCache::FindFont(FOPHokFontStyle &hokFontStyle, CDC *pDC)
{
	POSITION pos = GetHeadPosition();
	while (pos)
	{
		FOPHokFont* pCurFont = GetNext(pos);
		if (pCurFont->m_fontStyle == hokFontStyle)
		{
			ASSERT(pCurFont->m_pFont);
			return pCurFont->m_pFont;
		}
	}
	return CreateFont(hokFontStyle, pDC);
}

Gdiplus::Font* CFOPHokFontCache::CreateFont(FOPHokFontStyle &hokFontStyle, CDC *pDC)
{
	FOPHokFont* hokFontTemp = new FOPHokFont();
	ASSERT(hokFontTemp);

	hokFontTemp->m_fontStyle = hokFontStyle;
	
#ifdef _UNICODE
	CString lpwstrText = hokFontStyle.GetFaceName();
#else if
	USES_CONVERSION;
	LPWSTR lpwstrText = A2W(hokFontStyle.GetFaceName());
#endif


	CFont *pFont = pDC->GetCurrentFont();
	
	LOGFONT lf;
	ZeroMemory(&lf, sizeof(lf));
	pFont->GetLogFont(&lf);

	FontFamily fontfamily(lpwstrText);
	hokFontTemp->m_pFont = new Gdiplus::Font(pDC->m_hDC,&lf);

	ASSERT(hokFontTemp->m_pFont);
	AddTail(hokFontTemp);

	int nCount = GetCount();
	if(nCount >= FO_MAX_GDI_OBJECTS)
	{
		FOPHokFont *pFontTemp = GetHead();
		if(pFontTemp != NULL)
		{
			RemoveAt(GetHeadPosition());
			_SafeDeletePtr(pFontTemp->m_pFont);
			_SafeDeletePtr(pFontTemp);
		}
	}

	TRACE(_T("Create: Font Count: (%d)\n"), GetCount());
	return hokFontTemp->m_pFont;
}

FOPHokFontStyle CFOPHokFontCache::GetStyle(Gdiplus::Font* pFont)
{
	POSITION pos = GetHeadPosition();
	while (pos)
	{
		FOPHokFont* pCurFont = GetNext(pos);
		if (pCurFont->m_pFont == pFont)
		{
			return pCurFont->m_fontStyle;
		}
	}
	FOPHokFontStyle hokFontStyle;
	return hokFontStyle;
}

Gdiplus::Font* CFOPHokFontCache::GetFont(CFont *pFont, CDC *pDC)
{
//	return NULL;
	if (NULL == pFont) 
		return NULL;

	LOGFONT lplf;
	ZeroMemory(&lplf, sizeof(lplf));
	pFont->GetLogFont(&lplf);
	
	FOPHokFontStyle hokFontStyle;
	hokFontStyle.SetHeight(REAL(-lplf.lfHeight));
	if (lplf.lfItalic == TRUE) 
	{
		hokFontStyle.SetFontStyle((FontStyle)(hokFontStyle.GetFontStyle()|FontStyleItalic));
	}

	if (lplf.lfUnderline == TRUE) 
	{
		hokFontStyle.SetFontStyle((FontStyle)(hokFontStyle.GetFontStyle()|FontStyleUnderline));
	}

	if (lplf.lfWeight >= 700) 
	{
		hokFontStyle.SetFontStyle((FontStyle)(hokFontStyle.GetFontStyle()|FontStyleBold));
	}
	else
	{
		hokFontStyle.SetFontStyle((FontStyle)(hokFontStyle.GetFontStyle()|FontStyleRegular));
	}

	hokFontStyle.SetHeight(REAL(lplf.lfHeight));
	
	hokFontStyle.SetFaceName(CString(lplf.lfFaceName));

	return FindFont(hokFontStyle, pDC);	
}
